;
; MOUSEA.ASM - Assembly helper file for MOUSE.C
;
;              Copyright (c) 1994 by Borland International
;              All Rights Reserved.
;
;
IFDEF __DPMI32__
  .386P
  .model flat, C
ELSE
  .model large, C
ENDIF

.data
  extrn x : word
  extrn y : word
  extrn L : word
  extrn R : word
IFDEF __DPMI32__
  tempds dw 0
ENDIF

.code

; sets the user defined mouse event handler
setHandler proc
IFDEF __DPMI32__
  push es
  mov [tempds], ds         ; save DS for later use
  mov eax, 0Ch
  mov ecx, 31
  push cs
  pop es
  mov edx, offset Handler
  int 33h
  pop es
ELSE
  mov ax, 0Ch
  mov cx, 31
  mov dx, seg Handler
  mov es, dx
  mov dx, offset Handler
  int 33h
ENDIF
  ret
setHandler endp

; user defined mouse event handler
Handler proc
IFDEF __DPMI32__
  push ds
  mov ds, cs:[tempds]      ; load DS from the variable via the CS reg.
ELSE
  mov ax, @data
  mov ds, ax
ENDIF
  mov [x], cx
  mov [y], dx
  mov [L], bx
  and [L], 1
  mov [R], bx
  and [R], 10b
  shr [R], 1
IFDEF __DPMI32__
  pop ds
ENDIF
  ret
Handler endp
PUBLIC setHandler
end